JsonCpp project page | Classes | Namespace | JsonCpp home page

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | Friends | List of all members
Json::Value Class Reference

Represents a JSON value. More...

`#include <json/value.h>`

Collaboration diagram for Json::Value:

## Public Types
using | Members = std::vector<String>
using | iterator = ValueIterator
using | const_iterator = ValueConstIterator
using | UInt = Json::UInt
using | Int = Json::Int
using | UInt64 = Json::UInt64
using | Int64 = Json::Int64
using | LargestInt = Json::LargestInt
using | LargestUInt = Json::LargestUInt
using | ArrayIndex = Json::ArrayIndex
using | value_type = std::string

## Public Member Functions
| Value (ValueType type=nullValue)
| Create a default Value of the given type.
| Value (Int value)
| Value (UInt value)
| Value (Int64 value)
| Value (UInt64 value)
| Value (double value)
| Value (const char *value)
| Copy til first 0. (NULL causes to seg-fault.)
| Value (const char *begin, const char *end)
| Copy all, incl zeroes.
| Value (const StaticString &value)
| Constructs a value from a static string.
| Value (const String &value)
| Value (bool value)
| Value (std::nullptr_t ptr)=delete
| Value (const Value &other)
| Value (Value &&other) noexcept
| ~Value ()
Value & | operator= (const Value &other)
Value & | operator= (Value &&other) noexcept
void | swap (Value &other)
| Swap everything.
void | swapPayload (Value &other)
| Swap values but leave comments and source offsets in place.
void | copy (const Value &other)
| copy everything.
void | copyPayload (const Value &other)
| copy values but leave comments and source offsets in place.
ValueType | type () const
bool | operator< (const Value &other) const
| Compare payload only, not comments etc.
bool | operator<= (const Value &other) const
bool | operator>= (const Value &other) const
bool | operator> (const Value &other) const
bool | operator== (const Value &other) const
bool | operator!= (const Value &other) const
int | compare (const Value &other) const
const char * | asCString () const
| Embedded zeroes could cause you trouble!
String | asString () const
| Embedded zeroes are possible.
bool | getString (char const **begin, char const **end) const
| Get raw char* of string-value.
Int | asInt () const
UInt | asUInt () const
Int64 | asInt64 () const
UInt64 | asUInt64 () const
LargestInt | asLargestInt () const
LargestUInt | asLargestUInt () const
float | asFloat () const
double | asDouble () const
bool | asBool () const
bool | isNull () const
bool | isBool () const
bool | isInt () const
bool | isInt64 () const
bool | isUInt () const
bool | isUInt64 () const
bool | isIntegral () const
bool | isDouble () const
bool | isNumeric () const
bool | isString () const
bool | isArray () const
bool | isObject () const
template<typename T >
T | as () const =delete
| The `as<T>` and `is<T>` member function templates and specializations.
template<typename T >
bool | is () const =delete
bool | isConvertibleTo (ValueType other) const
ArrayIndex | size () const
| Number of values in array or object.
bool | empty () const
| Return true if empty array, empty object, or null; otherwise, false.
| operator bool () const
| Return !isNull()
void | clear ()
| Remove all object members and array elements.
void | resize (ArrayIndex newSize)
| Resize the array to newSize elements.
Value | get (ArrayIndex index, const Value &defaultValue) const
| If the array contains at least index+1 elements, returns the element value, otherwise returns defaultValue.
bool | isValidIndex (ArrayIndex index) const
| Return true if index < size().
Value & | append (const Value &value)
| Append value to array at the end.
Value & | append (Value &&value)
bool | insert (ArrayIndex index, const Value &newValue)
| Insert value in array at specific index.
bool | insert (ArrayIndex index, Value &&newValue)
Value & | operator[] (const char *key)
| Access an object value by name, create a null member if it does not exist.
const Value & | operator[] (const char *key) const
| Access an object value by name, returns null if there is no member with that name.
Value & | operator[] (const String &key)
| Access an object value by name, create a null member if it does not exist.
const Value & | operator[] (const String &key) const
| Access an object value by name, returns null if there is no member with that name.
Value & | operator[] (const StaticString &key)
| Access an object value by name, create a null member if it does not exist.
Value | get (const char *key, const Value &defaultValue) const
| Return the member named key if it exist, defaultValue otherwise.
Value | get (const char *begin, const char *end, const Value &defaultValue) const
| Return the member named key if it exist, defaultValue otherwise.
Value | get (const String &key, const Value &defaultValue) const
| Return the member named key if it exist, defaultValue otherwise.
Value const * | find (char const *begin, char const *end) const
| Most general and efficient version of isMember()const, get()const, and operator[]const.
Value const * | find (const String &key) const
| Most general and efficient version of isMember()const, get()const, and operator[]const.
Value * | demand (char const *begin, char const *end)
| Most general and efficient version of object-mutators.
void | removeMember (const char *key)
| Remove and return the named member.
void | removeMember (const String &key)
| Same as removeMember(const char*)
bool | removeMember (const char *key, Value *removed)
| Same as removeMember(const char* begin, const char* end, Value* removed), but 'key' is null-terminated.
bool | removeMember (String const &key, Value *removed)
| Remove the named map member.
bool | removeMember (const char *begin, const char *end, Value *removed)
| Same as removeMember(String const& key, Value* removed)
bool | removeIndex (ArrayIndex index, Value *removed)
| Remove the indexed array element.
bool | isMember (const char *key) const
| Return true if the object has a member named key.
bool | isMember (const String &key) const
| Return true if the object has a member named key.
bool | isMember (const char *begin, const char *end) const
| Same as isMember(String const& key)const.
Members | getMemberNames () const
| Return a list of the member names.
| __declspec (deprecated("Use setComment(String const&) instead.")) void setComment(const char *comment
void | setComment (const char *comment, size_t len, CommentPlacement placement)
| Comments must be //... or /* ... *‍/.
void | setComment (String comment, CommentPlacement placement)
| Comments must be //... or /* ... *‍/.
bool | hasComment (CommentPlacement placement) const
String | getComment (CommentPlacement placement) const
| Include delimiters and embedded newlines.
String | toStyledString () const
const_iterator | begin () const
const_iterator | end () const
iterator | begin ()
iterator | end ()
const Value & | front () const
| Returns a reference to the first element in the `Value`.
Value & | front ()
| Returns a reference to the first element in the `Value`.
const Value & | back () const
| Returns a reference to the last element in the `Value`.
Value & | back ()
| Returns a reference to the last element in the `Value`.
void | setOffsetStart (ptrdiff_t start)
void | setOffsetLimit (ptrdiff_t limit)
ptrdiff_t | getOffsetStart () const
ptrdiff_t | getOffsetLimit () const
template<>
bool | as () const
template<>
bool | is () const
template<>
Int | as () const
template<>
bool | is () const
template<>
UInt | as () const
template<>
bool | is () const
template<>
Int64 | as () const
template<>
bool | is () const
template<>
UInt64 | as () const
template<>
bool | is () const
template<>
double | as () const
template<>
bool | is () const
template<>
String | as () const
template<>
bool | is () const
template<>
float | as () const
| These `as` specializations are type conversions, and do not have a corresponding `is`.
template<>
const char * | as () const
Value & | operator[] (ArrayIndex index)
Value & | operator[] (int index)
const Value & | operator[] (ArrayIndex index) const
const Value & | operator[] (int index) const

## Static Public Member Functions
static Value const & | nullSingleton ()

## Public Attributes
CommentPlacement | placement

## Static Public Attributes
static const Value & | null = Value::nullSingleton()
static const Value & | nullRef = Value::nullSingleton()
static constexpr LargestInt | minLargestInt
| Minimum signed integer value that can be stored in a Json::Value.
static constexpr LargestInt | maxLargestInt = LargestInt(LargestUInt(-1) / 2)
| Maximum signed integer value that can be stored in a Json::Value.
static constexpr LargestUInt | maxLargestUInt = LargestUInt(-1)
| Maximum unsigned integer value that can be stored in a Json::Value.
static constexpr Int | minInt = Int(~(UInt(-1) / 2))
| Minimum signed int value that can be stored in a Json::Value.
static constexpr Int | maxInt = Int(UInt(-1) / 2)
| Maximum signed int value that can be stored in a Json::Value.
static constexpr UInt | maxUInt = UInt(-1)
| Maximum unsigned int value that can be stored in a Json::Value.
static constexpr Int64 | minInt64 = Int64(~(UInt64(-1) / 2))
| Minimum signed 64 bits int value that can be stored in a Json::Value.
static constexpr Int64 | maxInt64 = Int64(UInt64(-1) / 2)
| Maximum signed 64 bits int value that can be stored in a Json::Value.
static constexpr UInt64 | maxUInt64 = UInt64(-1)
| Maximum unsigned 64 bits int value that can be stored in a Json::Value.
static constexpr UInt | defaultRealPrecision = 17
| Default precision for real value for string representation.
static constexpr double | maxUInt64AsDouble = 18446744073709551615.0

## Friends
class | ValueIteratorBase

## Detailed Description

Represents a JSON value.

This class is a discriminated union wrapper that can represents a:

- signed integer [range: Value::minInt - Value::maxInt]
- unsigned integer (range: 0 - Value::maxUInt)
- double
- UTF-8 string
- boolean
- 'null'
- an ordered list of Value
- collection of name/value pairs (javascript object)

The type of the held value is represented by a ValueType and can be obtained using type().

Values of an objectValue or arrayValue can be accessed using operator[]() methods. Non-const methods will automatically create the a nullValue element if it does not exist. The sequence of an arrayValue will be automatically resized and initialized with nullValue. resize() can be used to enlarge or truncate an arrayValue.

The get() methods can be used to obtain default value in the case the required element does not exist.

It is possible to iterate over the list of member keys of an object using the getMemberNames() method.

Note
  Value string-length fit in size_t, but keys must be < 2^30. (The reason is an implementation detail.) A #CharReader will raise an exception if a bound is exceeded to avoid security holes in your app, but the Value API does not check bounds. That is the responsibility of the caller.

Definition at line 194 of file value.h.

## Member Typedef Documentation

## ◆ ArrayIndex

using Json::Value::ArrayIndex = Json::ArrayIndex

Definition at line 209 of file value.h.

## ◆ const_iterator

using Json::Value::const_iterator = ValueConstIterator

Definition at line 200 of file value.h.

## ◆ Int

using Json::Value::Int = Json::Int

Definition at line 202 of file value.h.

## ◆ Int64

using Json::Value::Int64 = Json::Int64

Definition at line 205 of file value.h.

## ◆ iterator

using Json::Value::iterator = ValueIterator

Definition at line 199 of file value.h.

## ◆ LargestInt

using Json::Value::LargestInt = Json::LargestInt

Definition at line 207 of file value.h.

## ◆ LargestUInt

using Json::Value::LargestUInt = Json::LargestUInt

Definition at line 208 of file value.h.

## ◆ Members

using Json::Value::Members = std::vector<String>

Definition at line 198 of file value.h.

## ◆ UInt

using Json::Value::UInt = Json::UInt

Definition at line 201 of file value.h.

## ◆ UInt64

using Json::Value::UInt64 = Json::UInt64

Definition at line 204 of file value.h.

## ◆ value_type

using Json::Value::value_type = std::string

Definition at line 212 of file value.h.

## Constructor & Destructor Documentation

## ◆ Value() [1/14]

Json::Value::Value | ( | ValueType | type = nullValue | ) |

Create a default Value of the given type.

This is a very useful constructor. To create an empty array, pass arrayValue. To create an empty object, pass objectValue. Another Value can then be set to this one by assignment. This is useful since clear() and resize() will not alter types.

Examples:

Json::Value null_value; // null
Json::Value arr_value(Json::arrayValue); // []
Json::Value obj_value(Json::objectValue); // {}
Json::Value
Represents a JSON value.
Definition value.h:194
Json::arrayValue
@ arrayValue
array value (ordered list)
Definition value.h:115
Json::objectValue
@ objectValue
object value (collection of name/value pairs).
Definition value.h:116

Default constructor initialization must be equivalent to: memset( this, 0, sizeof(Value) ) This optimization is used in ValueInternalMap fast allocator.

Definition at line 347 of file json_value.cpp.

References Json::arrayValue, Json::booleanValue, Json::intValue, JSON_ASSERT_UNREACHABLE, Json::nullValue, Json::objectValue, Json::realValue, Json::stringValue, and Json::uintValue.

## ◆ Value() [2/14]

Json::Value::Value | ( | Int | value | ) |

Definition at line 376 of file json_value.cpp.

References Json::intValue.

## ◆ Value() [3/14]

Json::Value::Value | ( | UInt | value | ) |

Definition at line 381 of file json_value.cpp.

References Json::uintValue.

## ◆ Value() [4/14]

Json::Value::Value | ( | Int64 | value | ) |

Definition at line 386 of file json_value.cpp.

References Json::intValue.

## ◆ Value() [5/14]

Json::Value::Value | ( | UInt64 | value | ) |

Definition at line 390 of file json_value.cpp.

References Json::uintValue.

## ◆ Value() [6/14]

Json::Value::Value | ( | double | value | ) |

Definition at line 396 of file json_value.cpp.

References Json::realValue.

## ◆ Value() [7/14]

Json::Value::Value | ( | const char * | value | ) |

Copy til first 0. (NULL causes to seg-fault.)

Definition at line 401 of file json_value.cpp.

References Json::duplicateAndPrefixStringValue(), JSON_ASSERT_MESSAGE, and Json::stringValue.

## ◆ Value() [8/14]

Json::Value::Value | ( | const char * | begin,
|  | const char * | end )

Copy all, incl zeroes.

Definition at line 409 of file json_value.cpp.

References Json::duplicateAndPrefixStringValue(), and Json::stringValue.

## ◆ Value() [9/14]

Json::Value::Value | ( | const StaticString & | value | ) |

Constructs a value from a static string.

Like other value string constructor but do not duplicate the string for internal storage. The given string must remain alive after the call to this constructor.

Note
  This works only for null-terminated strings. (We cannot change the size of this class, so we have nowhere to store the length, which might be computed later for various operations.)

Example of usage:

static StaticString foo("some text");
Json::Value aValue(foo);
Json::StaticString
Lightweight wrapper to tag static string.
Definition value.h:148

Definition at line 421 of file json_value.cpp.

References Json::StaticString::c_str(), and Json::stringValue.

## ◆ Value() [10/14]

Json::Value::Value | ( | const String & | value | ) |

Definition at line 415 of file json_value.cpp.

References Json::duplicateAndPrefixStringValue(), and Json::stringValue.

## ◆ Value() [11/14]

Json::Value::Value | ( | bool | value | ) |

Definition at line 426 of file json_value.cpp.

References Json::booleanValue.

## ◆ Value() [12/14]

Json::Value::Value | ( | std::nullptr_t | ptr | ) |
| delete

References Json::operator!=(), Json::operator==(), and Json::swap().

## ◆ Value() [13/14]

Json::Value::Value | ( | const Value & | other | ) |

Definition at line 431 of file json_value.cpp.

## ◆ Value() [14/14]

Json::Value::Value | ( | Value && | other | ) |
| noexcept

Definition at line 436 of file json_value.cpp.

References Json::nullValue, and Json::swap().

## ◆ ~Value()

Json::Value::~Value | ( |  | ) |

Definition at line 441 of file json_value.cpp.

## Member Function Documentation

## ◆ __declspec()

Json::Value::__declspec | ( | deprecated("Use setComment(String const&) instead.") |  | ) | const

Deprecated
  Always pass len.

## ◆ append() [1/2]

Value & Json::Value::append | ( | const Value & | value | ) |

Append value to array at the end.

Equivalent to jsonvalue[jsonvalue.size()] = value;

Definition at line 1129 of file json_value.cpp.

## ◆ append() [2/2]

Value & Json::Value::append | ( | Value && | value | ) |

Definition at line 1131 of file json_value.cpp.

References Json::arrayValue, JSON_ASSERT_MESSAGE, and Json::nullValue.

## ◆ as() [1/10]

template<>

bool Json::Value::as | ( |  | ) | const
| inline

Definition at line 681 of file value.h.

## ◆ as() [2/10]

template<>

Int Json::Value::as | ( |  | ) | const
| inline

Definition at line 684 of file value.h.

## ◆ as() [3/10]

template<>

UInt Json::Value::as | ( |  | ) | const
| inline

Definition at line 687 of file value.h.

## ◆ as() [4/10]

template<>

Int64 Json::Value::as | ( |  | ) | const
| inline

Definition at line 691 of file value.h.

## ◆ as() [5/10]

template<>

UInt64 Json::Value::as | ( |  | ) | const
| inline

Definition at line 694 of file value.h.

## ◆ as() [6/10]

template<>

double Json::Value::as | ( |  | ) | const
| inline

Definition at line 698 of file value.h.

## ◆ as() [7/10]

template<>

String Json::Value::as | ( |  | ) | const
| inline

Definition at line 701 of file value.h.

## ◆ as() [8/10]

template<>

float Json::Value::as | ( |  | ) | const
| inline

These `as` specializations are type conversions, and do not have a corresponding `is`.

Definition at line 706 of file value.h.

## ◆ as() [9/10]

template<>

const char * Json::Value::as | ( |  | ) | const
| inline

Definition at line 707 of file value.h.

## ◆ as() [10/10]

template<typename T >

T Json::Value::as | ( |  | ) | const
| delete

The `as<T>` and `is<T>` member function templates and specializations.

## ◆ asBool()

bool Json::Value::asBool | ( |  | ) | const

Definition at line 804 of file json_value.cpp.

References Json::booleanValue, Json::intValue, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, and Json::uintValue.

Referenced by Json::CharReaderBuilder::newCharReader(), and Json::StreamWriterBuilder::newStreamWriter().

Here is the caller graph for this function:

## ◆ asCString()

const char * Json::Value::asCString | ( |  | ) | const

Embedded zeroes could cause you trouble!

Definition at line 590 of file json_value.cpp.

References Json::decodePrefixedString(), JSON_ASSERT_MESSAGE, and Json::stringValue.

## ◆ asDouble()

double Json::Value::asDouble | ( |  | ) | const

Definition at line 759 of file json_value.cpp.

References Json::booleanValue, Json::intValue, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, and Json::uintValue.

## ◆ asFloat()

float Json::Value::asFloat | ( |  | ) | const

Definition at line 781 of file json_value.cpp.

References Json::booleanValue, Json::intValue, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, and Json::uintValue.

## ◆ asInt()

Value::Int Json::Value::asInt | ( |  | ) | const

Definition at line 654 of file json_value.cpp.

References Json::booleanValue, Json::InRange(), Json::intValue, JSON_ASSERT_MESSAGE, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, and Json::uintValue.

## ◆ asInt64()

Value::Int64 Json::Value::asInt64 | ( |  | ) | const

Definition at line 700 of file json_value.cpp.

References Json::booleanValue, Json::InRange(), Json::intValue, JSON_ASSERT_MESSAGE, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, and Json::uintValue.

## ◆ asLargestInt()

LargestInt Json::Value::asLargestInt | ( |  | ) | const

Definition at line 743 of file json_value.cpp.

## ◆ asLargestUInt()

LargestUInt Json::Value::asLargestUInt | ( |  | ) | const

Definition at line 751 of file json_value.cpp.

## ◆ asString()

String Json::Value::asString | ( |  | ) | const

Embedded zeroes are possible.

Definition at line 628 of file json_value.cpp.

References Json::booleanValue, Json::decodePrefixedString(), Json::intValue, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, Json::stringValue, Json::uintValue, and Json::valueToString().

Referenced by Json::StreamWriterBuilder::newStreamWriter().

Here is the caller graph for this function:

## ◆ asUInt()

Value::UInt Json::Value::asUInt | ( |  | ) | const

Definition at line 676 of file json_value.cpp.

References Json::booleanValue, Json::InRange(), Json::intValue, JSON_ASSERT_MESSAGE, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, and Json::uintValue.

Referenced by Json::CharReaderBuilder::newCharReader(), and Json::StreamWriterBuilder::newStreamWriter().

Here is the caller graph for this function:

## ◆ asUInt64()

Value::UInt64 Json::Value::asUInt64 | ( |  | ) | const

Definition at line 721 of file json_value.cpp.

References Json::booleanValue, Json::InRange(), Json::intValue, JSON_ASSERT_MESSAGE, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, and Json::uintValue.

## ◆ back() [1/2]

Value & Json::Value::back | ( |  | ) |
| inline

Returns a reference to the last element in the `Value`.

Requires that this value holds an array or json object, with at least one element.

Definition at line 957 of file value.h.

## ◆ back() [2/2]

const Value & Json::Value::back | ( |  | ) | const
| inline

Returns a reference to the last element in the `Value`.

Requires that value holds an array or json object, with at least one element.

Definition at line 955 of file value.h.

## ◆ begin() [1/2]

Value::iterator Json::Value::begin | ( |  | ) |

Definition at line 1474 of file json_value.cpp.

References Json::arrayValue, Json::objectValue, and type().

## ◆ begin() [2/2]

Value::const_iterator Json::Value::begin | ( |  | ) | const

Definition at line 1448 of file json_value.cpp.

References Json::arrayValue, Json::objectValue, and type().

Referenced by Json::CharReaderBuilder::validate(), and Json::StreamWriterBuilder::validate().

Here is the caller graph for this function:

## ◆ clear()

void Json::Value::clear | ( |  | ) |

Remove all object members and array elements.

Precondition
  type() is arrayValue, objectValue, or nullValue

Postcondition
  type() is unchanged

Definition at line 890 of file json_value.cpp.

References Json::arrayValue, JSON_ASSERT_MESSAGE, Json::nullValue, and Json::objectValue.

## ◆ compare()

int Json::Value::compare | ( | const Value & | other | ) | const

Definition at line 482 of file json_value.cpp.

## ◆ copy()

void Json::Value::copy | ( | const Value & | other | ) |

copy everything.

Definition at line 473 of file json_value.cpp.

## ◆ copyPayload()

void Json::Value::copyPayload | ( | const Value & | other | ) |

copy values but leave comments and source offsets in place.

Definition at line 461 of file json_value.cpp.

## ◆ demand()

Value * Json::Value::demand | ( | char const * | begin,
|  | char const * | end )

Most general and efficient version of object-mutators.

Note
  As stated elsewhere, behavior is undefined if (end-begin) >= 2^30

Returns
  non-zero, but JSON_ASSERT if this is neither object nor nullValue.

Definition at line 1098 of file json_value.cpp.

References JSON_ASSERT_MESSAGE, Json::nullValue, and Json::objectValue.

## ◆ empty()

bool Json::Value::empty | ( |  | ) | const

Return true if empty array, empty object, or null; otherwise, false.

Definition at line 882 of file json_value.cpp.

Referenced by Json::CharReaderBuilder::validate(), and Json::StreamWriterBuilder::validate().

Here is the caller graph for this function:

## ◆ end() [1/2]

Value::iterator Json::Value::end | ( |  | ) |

Definition at line 1487 of file json_value.cpp.

References Json::arrayValue, Json::objectValue, and type().

## ◆ end() [2/2]

Value::const_iterator Json::Value::end | ( |  | ) | const

Definition at line 1461 of file json_value.cpp.

References Json::arrayValue, Json::objectValue, and type().

Referenced by Json::CharReaderBuilder::validate(), and Json::StreamWriterBuilder::validate().

Here is the caller graph for this function:

## ◆ find() [1/2]

Value const * Json::Value::find | ( | char const * | begin,
|  | char const * | end ) const

Most general and efficient version of isMember()const, get()const, and operator[]const.

Note
  As stated elsewhere, behavior is undefined if (end-begin) >= 2^30

Definition at line 1082 of file json_value.cpp.

References JSON_ASSERT_MESSAGE, Json::nullValue, and Json::objectValue.

## ◆ find() [2/2]

Value const * Json::Value::find | ( | const String & | key | ) | const

Most general and efficient version of isMember()const, get()const, and operator[]const.

Definition at line 1095 of file json_value.cpp.

## ◆ front() [1/2]

Value & Json::Value::front | ( |  | ) |
| inline

Returns a reference to the first element in the `Value`.

Requires that this value holds an array or json object, with at least one element.

Definition at line 953 of file value.h.

## ◆ front() [2/2]

const Value & Json::Value::front | ( |  | ) | const
| inline

Returns a reference to the first element in the `Value`.

Requires that this value holds an array or json object, with at least one element.

Definition at line 951 of file value.h.

## ◆ get() [1/4]

Value Json::Value::get | ( | ArrayIndex | index,
|  | const Value & | defaultValue ) const

If the array contains at least index+1 elements, returns the element value, otherwise returns defaultValue.

Definition at line 1075 of file json_value.cpp.

## ◆ get() [2/4]

Value Json::Value::get | ( | const char * | begin,
|  | const char * | end,
|  | const Value & | defaultValue ) const

Return the member named key if it exist, defaultValue otherwise.

Note
  deep copy
  key may contain embedded nulls.

Definition at line 1158 of file json_value.cpp.

## ◆ get() [3/4]

Value Json::Value::get | ( | const char * | key,
|  | const Value & | defaultValue ) const

Return the member named key if it exist, defaultValue otherwise.

Note
  deep copy

Definition at line 1163 of file json_value.cpp.

## ◆ get() [4/4]

Value Json::Value::get | ( | const String & | key,
|  | const Value & | defaultValue ) const

Return the member named key if it exist, defaultValue otherwise.

Note
  deep copy

Parameters

  key | may contain embedded nulls.

Definition at line 1166 of file json_value.cpp.

## ◆ getComment()

String Json::Value::getComment | ( | CommentPlacement | placement | ) | const

Include delimiters and embedded newlines.

Definition at line 1426 of file json_value.cpp.

References placement.

## ◆ getMemberNames()

Value::Members Json::Value::getMemberNames | ( |  | ) | const

Return a list of the member names.

If null, return an empty list.

Precondition
  type() is objectValue or nullValue

Postcondition
  if type() was nullValue, it remains nullValue

Definition at line 1236 of file json_value.cpp.

References JSON_ASSERT_MESSAGE, Json::nullValue, and Json::objectValue.

## ◆ getOffsetLimit()

ptrdiff_t Json::Value::getOffsetLimit | ( |  | ) | const

Definition at line 1436 of file json_value.cpp.

Referenced by Json::Reader::pushError(), and Json::Reader::pushError().

Here is the caller graph for this function:

## ◆ getOffsetStart()

ptrdiff_t Json::Value::getOffsetStart | ( |  | ) | const

Definition at line 1434 of file json_value.cpp.

Referenced by Json::Reader::pushError(), and Json::Reader::pushError().

Here is the caller graph for this function:

## ◆ getString()

bool Json::Value::getString | ( | char const ** | begin,
|  | char const ** | end ) const

Get raw char* of string-value.

Returns
  false if !string. (Seg-fault if str or end are NULL.)

Definition at line 616 of file json_value.cpp.

References Json::decodePrefixedString(), and Json::stringValue.

## ◆ hasComment()

bool Json::Value::hasComment | ( | CommentPlacement | placement | ) | const

Definition at line 1422 of file json_value.cpp.

References placement.

Referenced by toStyledString().

Here is the caller graph for this function:

## ◆ insert() [1/2]

bool Json::Value::insert | ( | ArrayIndex | index,
|  | const Value & | newValue )

Insert value in array at specific index.

Definition at line 1140 of file json_value.cpp.

## ◆ insert() [2/2]

bool Json::Value::insert | ( | ArrayIndex | index,
|  | Value && | newValue )

Definition at line 1144 of file json_value.cpp.

References Json::arrayValue, JSON_ASSERT_MESSAGE, and Json::nullValue.

## ◆ is() [1/8]

template<>

bool Json::Value::is | ( |  | ) | const
| inline

Definition at line 682 of file value.h.

## ◆ is() [2/8]

template<>

bool Json::Value::is | ( |  | ) | const
| inline

Definition at line 685 of file value.h.

## ◆ is() [3/8]

template<>

bool Json::Value::is | ( |  | ) | const
| inline

Definition at line 688 of file value.h.

## ◆ is() [4/8]

template<>

bool Json::Value::is | ( |  | ) | const
| inline

Definition at line 692 of file value.h.

## ◆ is() [5/8]

template<>

bool Json::Value::is | ( |  | ) | const
| inline

Definition at line 695 of file value.h.

## ◆ is() [6/8]

template<>

bool Json::Value::is | ( |  | ) | const
| inline

Definition at line 699 of file value.h.

## ◆ is() [7/8]

template<>

bool Json::Value::is | ( |  | ) | const
| inline

Definition at line 702 of file value.h.

## ◆ is() [8/8]

template<typename T >

bool Json::Value::is | ( |  | ) | const
| delete

## ◆ isArray()

bool Json::Value::isArray | ( |  | ) | const

Definition at line 1373 of file json_value.cpp.

References Json::arrayValue.

Referenced by Json::Path::make(), Json::Reader::parse(), Json::Path::resolve(), and Json::Path::resolve().

Here is the caller graph for this function:

## ◆ isBool()

bool Json::Value::isBool | ( |  | ) | const

Definition at line 1259 of file json_value.cpp.

References Json::booleanValue.

## ◆ isConvertibleTo()

bool Json::Value::isConvertibleTo | ( | ValueType | other | ) | const

Definition at line 825 of file json_value.cpp.

References Json::arrayValue, Json::booleanValue, Json::InRange(), Json::intValue, JSON_ASSERT_UNREACHABLE, Json::nullValue, Json::objectValue, Json::realValue, Json::stringValue, and Json::uintValue.

## ◆ isDouble()

bool Json::Value::isDouble | ( |  | ) | const

Definition at line 1365 of file json_value.cpp.

References Json::intValue, Json::realValue, and Json::uintValue.

## ◆ isInt()

bool Json::Value::isInt | ( |  | ) | const

Definition at line 1261 of file json_value.cpp.

References Json::intValue, Json::IsIntegral(), Json::realValue, and Json::uintValue.

## ◆ isInt64()

bool Json::Value::isInt64 | ( |  | ) | const

Definition at line 1303 of file json_value.cpp.

References Json::intValue, Json::IsIntegral(), Json::realValue, and Json::uintValue.

## ◆ isIntegral()

bool Json::Value::isIntegral | ( |  | ) | const

Definition at line 1343 of file json_value.cpp.

References Json::intValue, Json::IsIntegral(), Json::realValue, and Json::uintValue.

## ◆ isMember() [1/3]

bool Json::Value::isMember | ( | const char * | begin,
|  | const char * | end ) const

Same as isMember(String const& key)const.

Definition at line 1225 of file json_value.cpp.

## ◆ isMember() [2/3]

bool Json::Value::isMember | ( | const char * | key | ) | const

Return true if the object has a member named key.

Note
  'key' must be null-terminated.

Definition at line 1229 of file json_value.cpp.

## ◆ isMember() [3/3]

bool Json::Value::isMember | ( | const String & | key | ) | const

Return true if the object has a member named key.

Parameters

  key | may contain embedded nulls.

Definition at line 1232 of file json_value.cpp.

## ◆ isNull()

bool Json::Value::isNull | ( |  | ) | const

Definition at line 1257 of file json_value.cpp.

References Json::nullValue.

## ◆ isNumeric()

bool Json::Value::isNumeric | ( |  | ) | const

Definition at line 1369 of file json_value.cpp.

## ◆ isObject()

bool Json::Value::isObject | ( |  | ) | const

Definition at line 1375 of file json_value.cpp.

References Json::objectValue.

Referenced by Json::Path::make(), Json::Reader::parse(), Json::Path::resolve(), and Json::Path::resolve().

Here is the caller graph for this function:

## ◆ isString()

bool Json::Value::isString | ( |  | ) | const

Definition at line 1371 of file json_value.cpp.

References Json::stringValue.

## ◆ isUInt()

bool Json::Value::isUInt | ( |  | ) | const

Definition at line 1280 of file json_value.cpp.

References Json::intValue, Json::IsIntegral(), Json::realValue, and Json::uintValue.

## ◆ isUInt64()

bool Json::Value::isUInt64 | ( |  | ) | const

Definition at line 1323 of file json_value.cpp.

References Json::intValue, Json::IsIntegral(), Json::realValue, and Json::uintValue.

## ◆ isValidIndex()

bool Json::Value::isValidIndex | ( | ArrayIndex | index | ) | const

Return true if index < size().

Definition at line 1080 of file json_value.cpp.

Referenced by Json::Path::resolve(), and Json::Path::resolve().

Here is the caller graph for this function:

## ◆ nullSingleton()

Value const & Json::Value::nullSingleton | ( |  | ) |
| static

Definition at line 70 of file json_value.cpp.

Referenced by Json::Path::resolve(), and Json::Path::resolve().

Here is the caller graph for this function:

## ◆ operator bool()

Json::Value::operator bool | ( |  | ) | const
| explicit

Return !isNull()

Definition at line 888 of file json_value.cpp.

## ◆ operator!=()

bool Json::Value::operator!= | ( | const Value & | other | ) | const

Definition at line 588 of file json_value.cpp.

## ◆ operator<()

bool Json::Value::operator< | ( | const Value & | other | ) | const

Compare payload only, not comments etc.

Definition at line 490 of file json_value.cpp.

References Json::arrayValue, Json::booleanValue, Json::decodePrefixedString(), Json::intValue, JSON_ASSERT, JSON_ASSERT_UNREACHABLE, Json::nullValue, Json::objectValue, Json::realValue, Json::stringValue, type(), and Json::uintValue.

## ◆ operator<=()

bool Json::Value::operator<= | ( | const Value & | other | ) | const

Definition at line 540 of file json_value.cpp.

## ◆ operator=() [1/2]

Value & Json::Value::operator= | ( | const Value & | other | ) |

Note
  Overwrite existing comments. To preserve comments, use swapPayload().

Definition at line 446 of file json_value.cpp.

References swap().

## ◆ operator=() [2/2]

Value & Json::Value::operator= | ( | Value && | other | ) |
| noexcept

Definition at line 451 of file json_value.cpp.

## ◆ operator==()

bool Json::Value::operator== | ( | const Value & | other | ) | const

Definition at line 546 of file json_value.cpp.

References Json::arrayValue, Json::booleanValue, Json::decodePrefixedString(), Json::intValue, JSON_ASSERT, JSON_ASSERT_UNREACHABLE, Json::nullValue, Json::objectValue, Json::realValue, Json::stringValue, type(), and Json::uintValue.

## ◆ operator>()

bool Json::Value::operator> | ( | const Value & | other | ) | const

Definition at line 544 of file json_value.cpp.

## ◆ operator>=()

bool Json::Value::operator>= | ( | const Value & | other | ) | const

Definition at line 542 of file json_value.cpp.

## ◆ operator[]() [1/9]

Value & Json::Value::operator[] | ( | ArrayIndex | index | ) |

Access an array element (zero based index). If the array contains less than index element, then null value are inserted in the array so that its size is index+1. (You may need to say 'value[0u]' to get your compiler to distinguish this from the operator[] which takes a string.)

Definition at line 925 of file json_value.cpp.

References Json::arrayValue, JSON_ASSERT_MESSAGE, and Json::nullValue.

## ◆ operator[]() [2/9]

const Value & Json::Value::operator[] | ( | ArrayIndex | index | ) | const

Access an array element (zero based index). (You may need to say 'value[0u]' to get your compiler to distinguish this from the operator[] which takes a string.)

Definition at line 948 of file json_value.cpp.

References Json::arrayValue, JSON_ASSERT_MESSAGE, and Json::nullValue.

## ◆ operator[]() [3/9]

Value & Json::Value::operator[] | ( | const char * | key | ) |

Access an object value by name, create a null member if it does not exist.

Note
  Because of our implementation, keys are limited to 2^30 -1 chars. Exceeding that will cause an exception.

Definition at line 1117 of file json_value.cpp.

## ◆ operator[]() [4/9]

const Value & Json::Value::operator[] | ( | const char * | key | ) | const

Access an object value by name, returns null if there is no member with that name.

Definition at line 1104 of file json_value.cpp.

## ◆ operator[]() [5/9]

Value & Json::Value::operator[] | ( | const StaticString & | key | ) |

Access an object value by name, create a null member if it does not exist.

If the object has no entry for that name, then the member name used to store the new entry is not duplicated. Example of use:

Json::Value object;
static const StaticString code("code");
object[code] = 1234;

Definition at line 1125 of file json_value.cpp.

References Json::StaticString::c_str().

## ◆ operator[]() [6/9]

Value & Json::Value::operator[] | ( | const String & | key | ) |

Access an object value by name, create a null member if it does not exist.

Parameters

  key | may contain embedded nulls.

Definition at line 1121 of file json_value.cpp.

## ◆ operator[]() [7/9]

Value const & Json::Value::operator[] | ( | const String & | key | ) | const

Access an object value by name, returns null if there is no member with that name.

Parameters

  key | may contain embedded nulls.

Definition at line 1110 of file json_value.cpp.

## ◆ operator[]() [8/9]

Value & Json::Value::operator[] | ( | int | index | ) |

Definition at line 941 of file json_value.cpp.

References JSON_ASSERT_MESSAGE.

## ◆ operator[]() [9/9]

const Value & Json::Value::operator[] | ( | int | index | ) | const

Definition at line 961 of file json_value.cpp.

References JSON_ASSERT_MESSAGE.

## ◆ removeIndex()

bool Json::Value::removeIndex | ( | ArrayIndex | index,
|  | Value * | removed )

Remove the indexed array element.

O(n) expensive operations. Update 'removed' iff removed.

Returns
  true if removed (no exceptions)

Definition at line 1201 of file json_value.cpp.

References Json::arrayValue.

## ◆ removeMember() [1/5]

bool Json::Value::removeMember | ( | const char * | begin,
|  | const char * | end,
|  | Value * | removed )

Same as removeMember(String const& key, Value* removed)

Definition at line 1170 of file json_value.cpp.

References Json::objectValue.

## ◆ removeMember() [2/5]

void Json::Value::removeMember | ( | const char * | key | ) |

Remove and return the named member.

Do nothing if it did not exist.

Precondition
  type() is objectValue or nullValue

Postcondition
  type() is unchanged

Definition at line 1190 of file json_value.cpp.

References JSON_ASSERT_MESSAGE, Json::nullValue, and Json::objectValue.

## ◆ removeMember() [3/5]

bool Json::Value::removeMember | ( | const char * | key,
|  | Value * | removed )

Same as removeMember(const char* begin, const char* end, Value* removed), but 'key' is null-terminated.

Definition at line 1184 of file json_value.cpp.

## ◆ removeMember() [4/5]

void Json::Value::removeMember | ( | const String & | key | ) |

Same as removeMember(const char*)

Parameters

  key | may contain embedded nulls.

Definition at line 1199 of file json_value.cpp.

## ◆ removeMember() [5/5]

bool Json::Value::removeMember | ( | String const & | key,
|  | Value * | removed )

Remove the named map member.

Update 'removed' iff removed.

Parameters

  key | may contain embedded nulls.

Returns
  true iff removed (no exceptions)

Definition at line 1187 of file json_value.cpp.

## ◆ resize()

void Json::Value::resize | ( | ArrayIndex | newSize | ) |

Resize the array to newSize elements.

New elements are initialized to null. May only be called on nullValue or arrayValue.

Precondition
  type() is arrayValue or nullValue

Postcondition
  type() is arrayValue

Definition at line 906 of file json_value.cpp.

References Json::arrayValue, JSON_ASSERT, JSON_ASSERT_MESSAGE, and Json::nullValue.

## ◆ setComment() [1/2]

void Json::Value::setComment | ( | const char * | comment,
|  | size_t | len,
|  | CommentPlacement | placement )
| inline

Comments must be //... or /* ... *‍/.

Definition at line 574 of file value.h.

Referenced by Json::Reader::parse().

Here is the caller graph for this function:

## ◆ setComment() [2/2]

void Json::Value::setComment | ( | String | comment,
|  | CommentPlacement | placement )

Comments must be //... or /* ... *‍/.

Definition at line 1411 of file json_value.cpp.

References JSON_ASSERT_MESSAGE, and placement.

## ◆ setOffsetLimit()

void Json::Value::setOffsetLimit | ( | ptrdiff_t | limit | ) |

Definition at line 1432 of file json_value.cpp.

## ◆ setOffsetStart()

void Json::Value::setOffsetStart | ( | ptrdiff_t | start | ) |

Definition at line 1430 of file json_value.cpp.

## ◆ size()

ArrayIndex Json::Value::size | ( |  | ) | const

Number of values in array or object.

Definition at line 859 of file json_value.cpp.

References Json::arrayValue, Json::booleanValue, Json::intValue, JSON_ASSERT_UNREACHABLE, Json::nullValue, Json::objectValue, Json::realValue, Json::stringValue, and Json::uintValue.

## ◆ swap()

void Json::Value::swap | ( | Value & | other | ) |

Swap everything.

Definition at line 466 of file json_value.cpp.

Referenced by operator=(), and Json::swap().

Here is the caller graph for this function:

## ◆ swapPayload()

void Json::Value::swapPayload | ( | Value & | other | ) |

Swap values but leave comments and source offsets in place.

Definition at line 456 of file json_value.cpp.

## ◆ toStyledString()

String Json::Value::toStyledString | ( |  | ) | const

Definition at line 1438 of file json_value.cpp.

References Json::commentBefore, hasComment(), and Json::writeString().

## ◆ type()

ValueType Json::Value::type | ( |  | ) | const

Definition at line 478 of file json_value.cpp.

Referenced by begin(), begin(), end(), end(), operator<(), and operator==().

Here is the caller graph for this function:

## Friends And Related Symbol Documentation

## ◆ ValueIteratorBase

friend class ValueIteratorBase
| friend

Definition at line 195 of file value.h.

## Member Data Documentation

## ◆ allocated_

unsigned int Json::Value::allocated_

Definition at line 655 of file value.h.

## ◆ defaultRealPrecision

UInt Json::Value::defaultRealPrecision = 17
| staticconstexpr

Default precision for real value for string representation.

Definition at line 247 of file value.h.

## ◆ maxInt

Int Json::Value::maxInt = Int(UInt(-1) / 2)
| staticconstexpr

Maximum signed int value that can be stored in a Json::Value.

Definition at line 234 of file value.h.

Referenced by Json::duplicateAndPrefixStringValue(), and Json::duplicateStringValue().

## ◆ maxInt64

Int64 Json::Value::maxInt64 = Int64(UInt64(-1) / 2)
| staticconstexpr

Maximum signed 64 bits int value that can be stored in a Json::Value.

Definition at line 242 of file value.h.

## ◆ maxLargestInt

LargestInt Json::Value::maxLargestInt = LargestInt(LargestUInt(-1) / 2)
| staticconstexpr

Maximum signed integer value that can be stored in a Json::Value.

Definition at line 227 of file value.h.

Referenced by Json::valueToString().

## ◆ maxLargestUInt

LargestUInt Json::Value::maxLargestUInt = LargestUInt(-1)
| staticconstexpr

Maximum unsigned integer value that can be stored in a Json::Value.

Definition at line 229 of file value.h.

## ◆ maxUInt

UInt Json::Value::maxUInt = UInt(-1)
| staticconstexpr

Maximum unsigned int value that can be stored in a Json::Value.

Definition at line 236 of file value.h.

## ◆ maxUInt64

UInt64 Json::Value::maxUInt64 = UInt64(-1)
| staticconstexpr

Maximum unsigned 64 bits int value that can be stored in a Json::Value.

Definition at line 244 of file value.h.

## ◆ maxUInt64AsDouble

double Json::Value::maxUInt64AsDouble = 18446744073709551615.0
| staticconstexpr

Definition at line 251 of file value.h.

## ◆ minInt

Int Json::Value::minInt = Int(~(UInt(-1) / 2))
| staticconstexpr

Minimum signed int value that can be stored in a Json::Value.

Definition at line 232 of file value.h.

## ◆ minInt64

Int64 Json::Value::minInt64 = Int64(~(UInt64(-1) / 2))
| staticconstexpr

Minimum signed 64 bits int value that can be stored in a Json::Value.

Definition at line 240 of file value.h.

## ◆ minLargestInt

LargestInt Json::Value::minLargestInt
| staticconstexpr

Initial value:
=
LargestInt(~(LargestUInt(-1) / 2))
Json::Value::LargestInt
Json::LargestInt LargestInt
Definition value.h:207
Json::Value::LargestUInt
Json::LargestUInt LargestUInt
Definition value.h:208

Minimum signed integer value that can be stored in a Json::Value.

Definition at line 224 of file value.h.

Referenced by Json::valueToString().

## ◆ null

Value const & Json::Value::null = Value::nullSingleton()
| static

Definition at line 216 of file value.h.

## ◆ nullRef

Value const & Json::Value::nullRef = Value::nullSingleton()
| static

Definition at line 217 of file value.h.

## ◆ placement

CommentPlacement Json::Value::placement

Initial value:
{
setComment(String(comment, strlen(comment)), placement)
Json::Value::setComment
void setComment(const char *comment, size_t len, CommentPlacement placement)
Comments must be //... or /* ... *‍/.
Definition value.h:574
Json::Value::placement
CommentPlacement placement
Definition value.h:570
Json::String
std::basic_string< char, std::char_traits< char >, Allocator< char > > String
Definition config.h:132

Definition at line 570 of file value.h.

Referenced by getComment(), hasComment(), and setComment().

## ◆ value_type_

unsigned int Json::Value::value_type_

Definition at line 653 of file value.h.

The documentation for this class was generated from the following files:

- include/json/value.h
- src/lib_json/json_value.cpp